void *memset(void *s, int c, int n)
{
	register int i;
	unsigned char c0 = (unsigned char)c;
	unsigned short c1;
	unsigned int c2;
	unsigned long long c3;
	if ( ((unsigned int)(s+n) & ~0x7) >= (((unsigned int)s & ~0x7) + 8)) {
		c1 = ((unsigned short)c0 << 8) | c0;
		c2 = ((unsigned int)c1 << 16) | c1;
		c3 = ((unsigned long long)c2 << 32) | c2;
		switch ((unsigned int)s & 0x7) {
			case 1:
				*(unsigned char *)(s) = c0;
				*(unsigned short *)(s+1) = c1;
				*(unsigned int *)(s+3) = c2;
				break;
			case 2:
				*(unsigned short *)(s) = c1;
				*(unsigned int *)(s+2) = c2;
				break;
			case 3:
				*(unsigned char *)(s) = c0;
				*(unsigned int *)(s+1) = c2;
				break;
			case 4:
				*(unsigned int *)(s) = c2;
				break;
			case 5:
				*(unsigned char *)(s) = c0;
				*(unsigned short *)(s+1) = c1;
				break;
			case 6:
				*(unsigned short *)(s) = c1;
				break;
			case 7:
				*(unsigned char *)(s) = c0;
				break;
		}
		switch ((unsigned int)(s+n) & 0x7) {
			case 1:
				*(unsigned char *)(s+n-1) = c0;
				break;
			case 2:
				*(unsigned short *)(s+n-2) = c1;
				break;
			case 3:
				*(unsigned char *)(s+n-1) = c0;
				*(unsigned short *)(s+n-3) = c1;
				break;
			case 4:
				*(unsigned int *)(s+n-4) = c2;
				break;
			case 5:
				*(unsigned char *)(s+n-1) = c0;
				*(unsigned int *)(s+n-5) = c2;
				break;
			case 6:
				*(unsigned short *)(s+n-2) = c1;
				*(unsigned int *)(s+n-6) = c2;
				break;
			case 7:
				*(unsigned char *)(s+n-1) = c0;
				*(unsigned short *)(s+n-3) = c1;
				*(unsigned int *)(s+n-7) = c2;
				break;
		}

		void *tmp = (void *)((unsigned int)(s+7)&~0x7);
		asm (
			"ldc1 $f16,%0\n\t"
			:
			:"m"(c3)
		    );


		for (n = (((unsigned int)(s+n)&~0x7) - (((unsigned int)(s+7)&~0x7))); n > 0;) {
			if (n >= 128) {
				asm (
					"sdc1 $f16,0(%0)\n\t"
					"sdc1 $f16,0x8(%0)\n\t"
					"sdc1 $f16,0x10(%0)\n\t"
					"sdc1 $f16,0x18(%0)\n\t"
					"sdc1 $f16,0x20(%0)\n\t"
					"sdc1 $f16,0x28(%0)\n\t"
					"sdc1 $f16,0x30(%0)\n\t"
					"sdc1 $f16,0x38(%0)\n\t"
					"sdc1 $f16,0x40(%0)\n\t"
					"sdc1 $f16,0x48(%0)\n\t"
					"sdc1 $f16,0x50(%0)\n\t"
					"sdc1 $f16,0x58(%0)\n\t"
					"sdc1 $f16,0x60(%0)\n\t"
					"sdc1 $f16,0x68(%0)\n\t"
					"sdc1 $f16,0x70(%0)\n\t"
					"sdc1 $f16,0x78(%0)\n\t"
					:
					:"r"(tmp)
					);
				tmp += 128;
				n -= 128;
				continue;
			}
			if (n >= 64) {
				asm (
					"sdc1 $f16,0(%0)\n\t"
					"sdc1 $f16,0x8(%0)\n\t"
					"sdc1 $f16,0x10(%0)\n\t"
					"sdc1 $f16,0x18(%0)\n\t"
					"sdc1 $f16,0x20(%0)\n\t"
					"sdc1 $f16,0x28(%0)\n\t"
					"sdc1 $f16,0x30(%0)\n\t"
					"sdc1 $f16,0x38(%0)\n\t"
					:
					:"r"(tmp)
				    );

				tmp += 64;
				n -= 64;
				continue;
			}
			if (n >= 32) {
				asm (
					"sdc1 $f16,0(%0)\n\t"
					"sdc1 $f16,0x8(%0)\n\t"
					"sdc1 $f16,0x10(%0)\n\t"
					"sdc1 $f16,0x18(%0)\n\t"
					:
					:"r"(tmp)
				    );
				tmp += 32;
				n -= 32;
				continue;
			}
			if (n >= 16) {
				asm (
					"sdc1 $f16,0(%0)\n\t"
					"sdc1 $f16,0x8(%0)\n\t"
					:
					:"r"(tmp)
				    );
				tmp += 16;
				n -= 16;
				continue;
			}
			asm (
					"sdc1 $f16,0(%0)\n\t"
					:
					:"r"(tmp)
			    );
			n -= 8;
		}
	} else {
		for (;n>0;n--)
			*(unsigned char *)(s+n-1) = c0;
	}
	return s;
}
